﻿Public Class Form1

    Private WithEvents Client1 As Client
    Private TimerGeneral As New System.Timers.Timer(1000)
    Private WithEvents GetIPBackgroundWorker As BackgroundWorker

    Private Delegate Sub UpdateUIDelegate(ByVal Code As Integer, ByVal ExtraData As Object)

    Private Sub MainForm_Load(sender As Object, e As System.EventArgs) Handles Me.Load

        AddHandler TimerGeneral.Elapsed, AddressOf TimerGeneralEvent
        TimerGeneral.SynchronizingObject = Me

        Me.Text = PROGNAME
        Label18.Text = PROGNAME
        Label19.Text = "Version " & VERSION
        ReadConfig()
        ComboBox1.Items.AddRange(GetWaveOutDevCaps)
        ComboBox1.Text = WaveOutID
        If ComboBox2.Items.Count > 0 Then ComboBox2.SelectedIndex = 0
        TimerGeneral.Start()
        VolumeControl1.Level = AudioLevel
        VolumeControl1.Mute = AudioMute
        ProgramFinishedLoading = True
        If CheckBox1.Checked Then Button1_Click(Nothing, Nothing)

    End Sub

    Private Sub MainForm_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        ProgramClosing = True

        If Client1 IsNot Nothing Then
            Client1.Close()
            Client1 = Nothing
        End If

        WriteConfig()

    End Sub

    Private Sub TimerGeneralEvent(source As Object, e As ElapsedEventArgs)

        If ProgramFinishedLoading = False Then Return
        If ProgramClosing = True Then Return

        Dim t As New Thread(AddressOf TimerGeneralEventThread1)
        t.Start()

    End Sub

    Private Sub TimerGeneralEventThread1()

        If ProgramClosing = True Then Return

        Static ThreadRunning As Boolean = False
        If ThreadRunning = True Then Return
        ThreadRunning = True

        If Client1 IsNot Nothing Then
            If TotalPackets > 0 Then
                UpdateGUI(4, New String() {BytesTX.ToString("#,##0"), BytesRX.ToString("#,##0"), FormatDuration(StartTime), CStr(Format(((LostPackets / TotalPackets) * 100), "0.00") & " %")})
            Else
                UpdateGUI(4, New String() {BytesTX.ToString("#,##0"), BytesRX.ToString("#,##0"), FormatDuration(StartTime), "0.00" & " %"})
            End If
        End If

        ThreadRunning = False

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click

        Static flag As Boolean 'prevents extra clicks occuring during state change
        If flag = True Then Return
        flag = True

        If Client1 IsNot Nothing Then
            Client1.Close()
            Client1 = Nothing
            Me.Cursor = Cursors.Default
        End If

        If Button1.Text = "Start" Then
            Button1.Text = "Stop"
            ComboBox1.Enabled = False
            Me.Cursor = Cursors.WaitCursor
            Application.DoEvents()
            Dim str1 As String = ComboBox2.Text.Trim
            If str1 <> String.Empty Then
                Dim resultIndex As Integer = ComboBox2.FindStringExact(str1)
                If resultIndex > -1 Then
                    ComboBox2.Items.RemoveAt(resultIndex)
                End If
                ComboBox2.Items.Insert(0, str1)
                If ComboBox2.Items.Count > 0 Then ComboBox2.SelectedIndex = 0
                If ComboBox2.Items.Count > 20 Then
                    ComboBox2.Items.RemoveAt(20)
                End If
            End If
            If IsNumericStr(Label21.Text) = False Then Label21.Text = "554"
            Client1 = New Client(ComboBox2.Text, WaveOutID, CInt(Label21.Text))
            Client1.Start()
        ElseIf Button1.Text = "Stop" Then
            Button1.Text = "Start"
            ComboBox1.Enabled = True
        End If

        flag = False

    End Sub

    Private Sub ComboBox1_DropDownClosed(sender As Object, e As System.EventArgs) Handles ComboBox1.DropDownClosed

        If WaveOutID <> ComboBox1.Text Then
            WaveOutID = ComboBox1.Text
            If Client1 IsNot Nothing Then
                Client1.StartWaveOut()
            End If
        End If

    End Sub

    Private Sub VolumeControl1_ValueChanged(Value As Object) Handles VolumeControl1.ValueChanged

        AudioLevel = CInt(Value)
        If Client1 IsNot Nothing AndAlso Client1.WaveOut1 IsNot Nothing Then
            Client1.WaveOut1.Level = AudioLevel
        End If

    End Sub

    Private Sub VolumeControl1_MuteChanged(Value As Object) Handles VolumeControl1.MuteChanged

        AudioMute = CBool(Value)
        If Client1 IsNot Nothing AndAlso Client1.WaveOut1 IsNot Nothing Then
            Client1.WaveOut1.Mute = AudioMute
        End If

    End Sub

    Private Function UpdateGUI(ByVal Code As Integer, ByVal Data As Object) As Object Handles Client1.UpdateGUI

        If InvokeRequired = False Then
            Return UpdateGUI1(Code, Data)
        Else
            Return Me.Invoke(New UpdateUIDelegate(AddressOf UpdateGUI1), New Object() {Code, Data})
        End If

    End Function

    Private Function UpdateGUI1(ByVal Code As Integer, ByVal Data As Object) As Object

        Select Case Code
            Case 1
                d(Data)
            Case 2
                Dim str1() As String = CType(Data, String())
                Label9.Text = str1(0)
                Label11.Text = str1(1)
            Case 3 'stop client
                If Client1 IsNot Nothing Then
                    Client1.Close()
                    Client1 = Nothing
                    Me.Cursor = Cursors.Default
                End If
                MessageBoxEx.Show(Me, CStr(Data))
                Button1.Text = "Start"
                ComboBox1.Enabled = True
            Case 4 'Bytes TX, RX, UpTime
                Dim str1() As String = CType(Data, String())
                Label13.Text = str1(0)
                Label15.Text = str1(1)
                Label16.Text = str1(2)
                Label27.Text = str1(3)
            Case 5 'start client
                Button1.Text = "Start"
                Button1_Click(Nothing, Nothing)
            Case 6
                Me.Cursor = Cursors.Default
        End Select

        Return Nothing

    End Function

    Private Sub Button14_Click(sender As System.Object, e As System.EventArgs) Handles Button14.Click


        If GetIPBackgroundWorker IsNot Nothing Then Return

        Cursor = Cursors.WaitCursor
        Application.DoEvents()

        GetIPBackgroundWorker = New BackgroundWorker
        GetIPBackgroundWorker.RunWorkerAsync()

    End Sub

    Private Sub GetIPBackgroundWorker_DoWork(sender As System.Object, e As System.ComponentModel.DoWorkEventArgs) Handles GetIPBackgroundWorker.DoWork
        'No GUI updates here

        Dim LocalIP As String = String.Empty
        Dim RemoteIP As String = String.Empty

        Try
            Dim iphe As System.Net.IPHostEntry = System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName)
            For Each ipheal As System.Net.IPAddress In iphe.AddressList
                If ipheal.AddressFamily = System.Net.Sockets.AddressFamily.InterNetwork Then
                    LocalIP = ipheal.ToString
                    Exit For
                End If
            Next
            RemoteIP = HttpDownloadString("http://www.proscan.org/SOIP/SOIP.php?action=getip")
        Catch ex As Exception
        End Try
        e.Result = New String() {LocalIP, RemoteIP}

    End Sub

    Private Sub GetIPBackgroundWorker_RunWorkerCompleted(sender As System.Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles GetIPBackgroundWorker.RunWorkerCompleted

        Dim data() As String = CType(e.Result, String())

        Label23.Text = data(0)
        Label24.Text = data(1)

        Cursor = Cursors.Arrow
        GetIPBackgroundWorker = Nothing

    End Sub

End Class
