﻿'TODO
' Send PSI on port 50536 and retrive text tags
' Jitter buffer
' Icon

Module General

    Public Const PROGNAME As String = "BCD536HP Audio Player"
    Public Const VERSION As String = "0.03"
    Public Const DEBUGLOG As String = "Debug Log.txt"

    Public WaveOutID As String
    Public StartTime As DateTime
    Public BytesTX As Long
    Public BytesRX As Long
    Public ProgramFinishedLoading As Boolean
    Public ProgramClosing As Boolean
    Public AudioLevel As Integer
    Public AudioMute As Boolean
    Public TotalPackets As Long
    Public LostPackets As Integer

    Public Function AppPath() As String

        Dim Path As String = Application.StartupPath

        If Path.EndsWith("\") = False Then Path &= "\"

        Return Path

    End Function

    Public Sub ReadConfig()

        On Error Resume Next

        With Form1
            'defaults in case config file don't exist or not in config file
            WaveOutID = "Primary Sound Playback Device"
            .Label21.Text = "554"
            .CheckBox1.Checked = False
            AudioLevel = 100
            AudioMute = False
            .Label23.Text = "0.0.0.0"
            .Label24.Text = "0.0.0.0"
            If File.Exists(AppPath() & PROGNAME & ".cfg") = True Then
                Dim lines() As String
                Dim str1 As String
                Dim int1 As Integer
                Dim temp() As String

                lines = IO.File.ReadAllLines(AppPath() & PROGNAME & ".cfg")
                For Each line As String In lines
                    int1 = InStr(line, "]=")
                    If int1 > 1 Then
                        str1 = Mid(line, int1 + 2)
                        Select Case Mid(line, 2, int1 - 2).Trim
                            Case "PROGRAM LOCATION"
                                If str1 <> String.Empty AndAlso InStr(str1, ",") > 0 Then
                                    temp = str1.Split(CChar(","))
                                    If temp.Length = 2 AndAlso IsNumericStr(temp(0)) AndAlso IsNumericStr(temp(1)) Then
                                        If CInt(temp(0)) < 0 Then temp(0) = "0" 'safeguard
                                        If CInt(temp(1)) < 0 Then temp(1) = "0"
                                        .Location = New Point(CInt(temp(0)), CInt(temp(1)))
                                    End If
                                End If
                            Case "PLAYBACK DEVICE ID"
                                If str1 <> String.Empty Then WaveOutID = str1
                            Case "TCP Scanner Port"
                                If str1 <> String.Empty Then .Label21.Text = str1
                            Case "AUTO START"
                                If str1 = "True" Then .CheckBox1.Checked = True Else .CheckBox1.Checked = False
                            Case "AUDIO LEVEL"
                                If IsNumericStr(str1) = True Then AudioLevel = CInt(str1)
                            Case "AUDIO MUTE"
                                If str1 = "True" Then AudioMute = True Else AudioMute = False
                            Case "URL 0"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 1"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 2"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 3"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 4"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 5"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 6"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 7"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 8"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 9"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 0"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 11"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 12"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 13"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 14"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 15"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 16"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 17"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 18"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "URL 19"
                                If str1 <> String.Empty Then .ComboBox2.Items.Add(str1)
                            Case "LOCAL IP"
                                If str1 <> String.Empty Then .Label23.Text = str1
                            Case "REMOTE IP"
                                If str1 <> String.Empty Then .Label24.Text = str1
                        End Select
                    End If
                Next
            End If
            If .ComboBox2.Items.Count = 0 Then
                .ComboBox2.Items.Add("rtsp://192.168.1.8/au:scanner.au")
            End If
        End With

    End Sub

    Public Sub WriteConfig()

        On Error Resume Next

        Dim str1 As String

        With Form1
            Using sw As New StreamWriter(AppPath() & PROGNAME & ".cfg", False)
                sw.WriteLine(PROGNAME & " " & "CONFIGURATION FILE")
                sw.WriteLine(String.Empty)
                sw.WriteLine("[PROGRAM LOCATION]=" & Form1.Location.X & "," & Form1.Location.Y)
                sw.WriteLine("[PLAYBACK DEVICE ID]=" & WaveOutID)
                sw.WriteLine("[TCP Scanner Port]=" & .Label21.Text)
                sw.WriteLine("[AUTO START]=" & .CheckBox1.Checked)
                sw.WriteLine("[AUDIO LEVEL]=" & AudioLevel)
                sw.WriteLine("[AUDIO MUTE]=" & AudioMute)
                For i = 0 To .ComboBox2.Items.Count - 1
                    str1 = CStr(.ComboBox2.Items(i))
                    If str1 <> String.Empty Then
                        sw.WriteLine("[URL " & i.ToString & "]=" & str1)
                    End If
                Next
                sw.WriteLine("[LOCAL IP]=" & .Label23.Text)
                sw.WriteLine("[REMOTE IP]=" & .Label24.Text)
            End Using
        End With

    End Sub

    Public Function GetWaveOutDevCaps() As String()

        Dim i As Integer
        Dim rc As Integer
        Dim str1(Wave.waveOutGetNumDevs + 1) As String
        Dim caps As Wave.WAVEOUTCAPS = Nothing
        Dim sz As Integer = Marshal.SizeOf(caps)

        str1(0) = "Primary Sound Playback Device"
        For i = 0 To Wave.waveOutGetNumDevs - 1
            rc = Wave.waveOutGetDevCaps(i, caps, sz)
            str1(i + 1) = caps.szPname.Trim
        Next i
        str1(str1.Length - 1) = "None"

        Return str1

    End Function

    Public Function GetWaveOutDeviceID(StringName As String) As Integer

        Dim i As Integer
        Dim rc As Integer
        Dim caps As Wave.WAVEOUTCAPS = Nothing
        Dim sz As Integer = Marshal.SizeOf(caps)

        If StringName = "Primary Sound Playback Device" Then Return -1
        For i = 0 To Wave.waveOutGetNumDevs - 1
            rc = Wave.waveOutGetDevCaps(i, caps, sz)
            If StringName = caps.szPname.Trim Then Return i
        Next i

        Return 9999

    End Function

    Public Function FormatDuration(Now1 As DateTime) As String

        If Now1 = Nothing Then Return "00:00:00"

        Dim span As TimeSpan = Now.Subtract(Now1)
        Dim str1 As String

        If span.Days = 0 Then
            str1 = CStr(span.Hours).PadLeft(2, CChar("0")) + ":" + CStr(span.Minutes).PadLeft(2, CChar("0")) + ":" + CStr(span.Seconds).PadLeft(2, CChar("0"))
        Else
            str1 = CStr(span.Days) + ":" + CStr(span.Hours).PadLeft(2, CChar("0")) + ":" + CStr(span.Minutes).PadLeft(2, CChar("0")) + ":" + CStr(span.Seconds).PadLeft(2, CChar("0"))
        End If

        Return str1

    End Function

    Public Function IsNumericStr(Expression As String) As Boolean
        'use this instead of of the .net method Isnumeric because the Culture can be specified here
        'for positive numbers only

        Dim isNum As Boolean
        Dim retNum As Double

        isNum = Double.TryParse(Convert.ToString(Expression), System.Globalization.NumberStyles.Any, System.Globalization.NumberFormatInfo.InvariantInfo, retNum)

        Return isNum

    End Function

    Public Function HttpDownloadString(RequestString As String, Optional Encoding1 As Encoding = Nothing) As String

        Try
            Dim webClient As New System.Net.WebClient

            If Encoding1 Is Nothing Then
                webClient.Encoding = Encoding.GetEncoding(28591)
            Else
                webClient.Encoding = Encoding1
            End If

            Return webClient.DownloadString(RequestString)
        Catch ex As Exception
            Return String.Empty
        End Try

    End Function

    Public Sub WriteDebugLog(Message As String)

        Dim nowdatetime As DateTime = Now

        Try
            If File.Exists(AppPath() & DEBUGLOG) AndAlso FileSystem.FileLen(AppPath() & DEBUGLOG) > 1000000 Then
                File.Delete(AppPath() & DEBUGLOG)
            End If

            If File.Exists(AppPath() & DEBUGLOG) = False Then
                FileWrite(AppPath() & DEBUGLOG, DEBUGLOG & vbCrLf, False)
            End If
            FileWrite(AppPath() & DEBUGLOG, Format(nowdatetime, "MM/dd/yy" & " " & Format(nowdatetime, "HH:mm:ss")) & " - " & Message, True)
        Catch ex As Exception
        End Try

    End Sub

    Public Sub FileWrite(FileName As String, Data As String, Append As Boolean)
        'Don't use StreamWriter.  FileStream has sharing permission

        Try
            If Append = False AndAlso File.Exists(FileName) = True Then File.Delete(FileName)
            Using fs As New FileStream(FileName, FileMode.Append, FileAccess.Write, FileShare.Write)
                Dim b() As Byte = Encoding.ASCII.GetBytes(Data)
                fs.Write(b, 0, b.Length)
                b = Encoding.ASCII.GetBytes(vbCrLf)
                fs.Write(b, 0, b.Length)
            End Using
        Catch ex As Exception
        End Try

    End Sub

    Public Sub Test_MeasureInterval()

        '*********************** for testing ***********************
#If DEBUG Then
        Static sw As New MyStopWatch

        d(Math.Round(sw.Peek))
        sw.Reset()
#End If

    End Sub

    Public Sub Test_MeasureIntervalAvg()

        '*********************** for testing ***********************
#If DEBUG Then
        Static sw As New MyStopWatch
        Static total As Double
        Static count As Integer

        If count = Integer.MaxValue - 1 Then
            total = 0
            count = 0
        End If
        total += sw.Peek
        count += 1

        d("Peek = " & CStr(Math.Round(sw.Peek, 1)).PadRight(7) & "Avg = " & Math.Round(total / count, 1))

        sw.Reset()
#End If

    End Sub

    Public Sub d(Bytes() As Byte)
        'FOR DELEVOPMENT  - It's easier to type d then Debug.WriteLine

#If DEBUG Then
        Debug.WriteLine(Encoding.GetEncoding(28591).GetString(Bytes))
#End If

    End Sub

    Public Sub d(ByVal obj As Object)
        'FOR DELEVOPMENT  - It's easier to type d then Debug.WriteLine

#If DEBUG Then
        Debug.WriteLine(CStr(obj))
#End If

    End Sub

End Module
