Public NotInheritable Class MyStopWatch

    Private _StartTime As Long
    Private _Frequency As Long

    Private Declare Ansi Function QueryPerformanceCounter Lib "kernel32.dll" (ByRef x As Long) As Integer
    Private Declare Ansi Function QueryPerformanceFrequency Lib "kernel32.dll" (ByRef x As Long) As Integer

    Public Sub New()

        If QueryPerformanceFrequency(_Frequency) = 0 Then Throw New NotSupportedException("Error while querying the performance counter frequency.")
        Reset()

    End Sub

    Public Sub Reset()

        _StartTime = GetValue()

    End Sub

    Public Function Peek() As Double

        Return (CType((((GetValue() - _StartTime) / CType(_Frequency, Double)) * 10000), Long) / CType(10, Single))

    End Function

    Private Function GetValue() As Long

        Dim ret As Long

        If QueryPerformanceCounter(ret) = 0 Then Throw New NotSupportedException("Error while querying the high-resolution performance counter.")

        Return ret

    End Function

End Class
